Redmine - Defect #5461

Cannot browse SVN Repositories with whitespaces in them
2010-05-07 01:34 - Grant McEwan

Status: Closed Start date: 2010-05-07
Priority: Normal Due date:

Assignee: % Done: 0%
Category: SCM Estimated time: 0.00 hour
Target version:

Resolution: Invalid Affected version:

Description

Hi,

| get a proxy error when browsing through the projects repository that has a white space
eg .. a failed svn url would be "https://hostname/svn/project with whitespace/"

actual error message looks like

The proxy server received an invalid response from an upstream server.
The proxy server could not handle the request GET /redmine/projects/<projectnames/repository/show/trunk/hardware/Main Board

Reason: Error reading from remote server

Is this just that i haven't changed my apache2 properly? or can this be fixed with apache2 at all? by what i see it's a case of redmine
not escaping the URL's correctly?

| have just updated the version to 0.9.4 (2010-05-01) and rails version 2.3.5 apache2 version 2.2.9

Related issues:

Related to Redmine - Defect #7505: Subversion: Repository URL with space not ... Closed 2011-01-31
Related to Redmine - Defect #2532: Cannot browse Subversion paths that contai... Closed 2009-01-19
History

#1 - 2010-05-07 08:16 - Felix Schéfer
- Category changed from Issues to SCM

Change the whitespaces to %20 and see if that helps.

#2 - 2010-05-07 11:12 - Grant McEwan

Doesn't seem to help? Any other information i can provide??

#3 - 2010-05-07 12:06 - Felix Schafer

Can you access https:/hostname/svn/project with whitespace/ from your browser? Can you login to the server running redmine and see what svn Is
https://hostname/svn/project with whitespace/ outputs, if possible as the user running redmine?

#4 - 2010-05-07 13:27 - Grant McEwan
Hi Felix,

as the user running redmine ... i can see the result of svn Is https://hostname/svn/project%20name/
but i can't see svn Is https://hostname/svn/project name/

Does that mean my apache is incorrectly set?

#5 - 2010-05-07 13:45 - Felix Schafer

No, but URLs can't have blanks in them, they only get replaced by browsers with %20, which is a placeholder for blanks. Redmine should work with
https://hostname/svn/project%20name/

#6 - 2010-05-08 11:16 - Grant McEwan
hmm ok - well it doesn't? When i click on the repository tab and click through to the svn url with the whitespace in it, it directs me back to the proxy
server error.

#7 - 2010-05-08 14:06 - Felix Schafer

Do you use a reverse proxy to server redmine?

#8 - 2010-05-09 23:03 - Grant McEwan
Nope - i don't.

#9 - 2010-05-10 00:35 - Grant McEwan

I've come to realize that i think the issue is with the "GET \ADDRESS\OF\URL" which is different to the address that is displayed in the browser
window.

Is anyone else seeing this sort of issue?

#10 - 2010-05-10 01:39 - Grant McEwan

Where abouts is the code that redmine uses to get the repository contents?

#11 - 2010-05-10 02:17 - Grant McEwan

Given that i could do
svn Is https://hostname/svn/project%20name/

but not
svn s https://hostname/svn/project name/

But i can do
svn Is "https://hostname/svn/project name/"

| turned on the debug output of redmine, tracing it back to
cmd = "#{SVN_BIN} list --xml #{target(URl.escape(path))}@#{identifier}" (in subversion adapter).

Not that i know what this is written in, but is it possible to pass the whole "#{target(URIl.escape(path))}@#{identifier}" with the quote marks? SVN
actually does all the decoding for us, so there's no need to escape it.

#12 - 2010-05-10 07:22 - Felix Schéfer

The error you get is (or looks very much like) an apache reverse proxy error, we won't be able to help you without knowing what error caused that. If
you have more information from the redmine logs, please post it here too.

Regarding the escaping of the URI: the URI.escape part should already format the blank to %20, which you state also works, so the problem is not
there.

| just setup a test repository, and it works fine with https://some.url/svn/This%20is%20%20a%20test%20repo/ as well as https://some.url/svn/This is a
test repo/ from my developments redmine. Please provide a way to reproduce, as this looks more and more like a problem with your setup rather than
with redmine.

#13 - 2010-05-11 01:37 - Grant McEwan
Hi Felix.

From the mongrel cluster log

Tue May 11 11:16:00 +1200 2010: HTTP parse error, malformed request (127.0.0.1): #<Mongrel::HttpParserError: Invalid HTTP format, parsing

fails.>

Tue May 11 11:16:00 +1200 2010: REQUEST DATA: "GET /redmine/projects/projecthardware/repository/show/hardware/Main Board

HTTP/1.1\r\nHost: 127.0.0.1:8001\r\nUser-Agent: Opera/9.80 (Windows NT 5.1; U; en) Presto/2.5.24 Version/10.53\r\nAccept: text/html,

application/xml;q=0.9, application/xhtml+xml, image/png, image/jpeg, image/gif, image/x-xbitmap, /*;q=0.1\r\nAccept-Language:

en-NZ,en;q=0.9\r\nAccept-Charset: is0-8859-1, utf-8, utf-16, *;q=0.1\r\nAccept-Encoding: deflate, gzip, x-gzip, identity, *;q=0\r\nReferer:

http://server/redmine/projects/projecthardware/repository/show/hardware\r\nCookie:

MOIN_SESSION_80_ROOT_4dwiki=4d84656c156d9e201ba%e9eea1676c918ee1c39b;
_redmine_session=BAh7CDoPc2Vzc2IvbI9pZCIIZjkwNWIwWZWU5YTQ3ZTQ2ZDZhN2NiZjRiMTMyNDAzOGE6DHVzZXJfaWRpCDoQX2NzcmZf

dG9rZW4iMUJrNTZIMjRIWXJock5ZQVYxUzBSdVEzeTR2eUNtMzNJTXVqeGJkUTdSUGc9--db9e979ae39da17f14aa8864c1e4260c123d9639\r\

nCookie2: $Version=1\r\nVia: 1.1 server\r\nX-Forwarded-For: 192.168.1.111\r\nX-Forwarded-Host: server\r\nX-Forwarded-Server:

server\r\nConnection: Keep-Alive\r\n\r\n"

PARAMS: {"REQUEST_PATH"=>"/redmine/projects/projecthardware/repository/show/hardware/Main",

"REQUEST_URI"=>"/redmine/projects/projecthardware/repository/show/hardware/Main", "REQUEST_METHOD"=>"GET"}

Tue May 11 11:16:01 +1200 2010: HTTP parse error, malformed request (127.0.0.1): #<Mongrel::HttpParserError: Invalid HTTP format,

parsing fails.>
https://hostname/svn/project%20name/
https://hostname/svn/project
http://server/redmine/projects/projecthardware/repository/show/hardware%5Cr%5CnCookie

Tue May 11 11:16:01 +1200 2010: REQUEST DATA: "GET /redmine/projects/projecthardware/repository/show/hardware/Main Board
HTTP/1.1\r\nHost: 127.0.0.1:8001\r\nUser-Agent: Opera/9.80 (Windows NT 5.1; U; en) Presto/2.5.24 Version/10.53\r\nAccept: text/html,
application/xml;q=0.9, application/xhtml+xml, image/png, image/jpeg, image/gif, image/x-xbitmap, */;q=0.1\r\nAccept-Language:
en-NZ,en;q=0.9\r\nAccept-Charset: is0-8859-1, utf-8, utf-16, *;g=0.1\r\nAccept-Encoding: deflate, gzip, x-gzip, identity, *;q=0\r\nReferer:
http://server/redmine/projects/projecthardware/repository/show/hardware\r\nCookie:
MOIN_SESSION_80_ROOT_4dwiki=4d84656c156d9e201ba9e9eeal1676c918ee1c39b;
_redmine_session=BAh7CDoPc2Vzc2Ivbl9pZClIZjkwNWIwZWU5YTQ3ZTQ2ZDZhN2NiZjRiMTMyNDAzOGEEDHVzZXJfaWRpCDoQX2NzcmZfdG9r
ZW4IMUJrNTZIM]RIWXJock5ZQVYxUzBSdVEze TR2eUNtMzNJTXVgeGJkUTASUGCc9--db9e979ae39dal7f14aa8864c1e4260c123d9639\r\nCookie2
: $Version=1\"\nVia: 1.1 server\\nX-Forwarded-For: 192.168.1.111\r\nX-Forwarded-Host: server\r\nX-Forwarded-Server: server\r\nConnection:
Keep-Alive\r\n\r\n"

PARAMS: {"REQUEST_PATH"=>"/redmine/projects/projecthardware/repository/show/hardware/Main",
"REQUEST_URI"=>"/redmine/projects/projecthardware/repository/show/hardware/Main", "REQUEST_METHOD"=>"GET"}

#14 - 2010-05-11 04:18 - Grant McEwan

- Status changed from New to Resolved

Hi Felix,
Success!! It was a reverse proxy problem.
In my apache config i needed to add

ProxyPass /redmine balancer://redmine_cluster:8000/redmine
ProxyPassReverse / balancer://redmine_cluster:8000/redmine

Thank you for your help there.

#15 - 2010-05-11 08:36 - Felix Schéfer
- Status changed from Resolved to Closed

- Resolution set to Invalid

Glad you got that worked out :-)
